hasDirectSuccessorWithYear = { u -> 
    successor = Successor(u)
    if(successor != null) {
        return UC_Year(successor) != null
    }
    return false
}

hasDirectPredecessorWithYear= { u -> 
    predecessor = Predecessor(u)
    if(predecessor != null) {
        return UC_Year(predecessor) != null
    }    
    return false
}
  

//List des U dont l'anne n'est pas renseigne mais qui est encadre par 2 UC renseignes.
uList = NodesFilter({node -> Order(node) == 1 && TypeName(node) =="u" && UC_Year(node) ==null && hasDirectSuccessorWithYear(node) && hasDirectPredecessorWithYear(node)})

 
for (u in uList) {

    predecessor = Predecessor(u)
    successor = Successor(u)
   
    previousYearUC = UC_Year(predecessor)
    nextYearUC = UC_Year(successor)
    
    lengthPre = UC_Lg(predecessor)
    lengthSuc = UC_Lg(successor)
    
    lengthCur = UC_Lg(u)
    
    if(lengthCur<lengthSuc) {
        u.set("UC_Year", previousYearUC)
    } else {
        u.set("UC_Year", nextYearUC)
    }
}

data = uList.collect({u -> [Index(Root(u)), Index(u), UC_Year(u),  UC_Lg(u),  UC_Year(Predecessor(u)), UC_Lg(Predecessor(u)), UC_Year(Successor(u)),UC_Lg(Successor(u))]})

Table(data, ["Individu", "UC", "Year", "Lg", "PrevYear", "PrevLg", "NextYear", "NextLg"])

Update()

